Package com.sun.ts.lib.util

# Class CharacterDecoder

java.lang.Object
com.sun.ts.lib.util.CharacterDecoder

Direct Known Subclasses:
  `BASE64Decoder`

public abstract class CharacterDecoder extends Object
This class defines the decoding half of character encoders. A character decoder is an algorithim for transforming 8 bit binary data that has been encoded into text by a character encoder, back into original binary form. The character encoders, in general, have been structured around a central theme that binary data can be encoded into text that has the form:

          [Buffer Prefix]
          [Line Prefix][encoded data atoms][Line Suffix]
          [Buffer Suffix]

Of course in the simplest encoding schemes, the buffer has no distinct prefix of suffix, however all have some fixed relationship between the text in an 'atom' and the binary data itself. In the CharacterEncoder and CharacterDecoder classes, one complete chunk of data is referred to as a buffer. Encoded buffers are all text, and decoded buffers (sometimes just referred to as buffers) are binary octets. To create a custom decoder, you must, at a minimum, overide three abstract methods in this class.

  bytesPerAtom which tells the decoder how many bytes to expect from decodeAtom
  decodeAtom which decodes the bytes sent to it as text.
  bytesPerLine which tells the encoder the maximum number of bytes per line.

In general, the character decoders return error in the form of a CEFormatException. The syntax of the detail string is

          DecoderClassName: Error message.

Several useful decoders have already been written and are referenced in the See Also list below.

Author:
  Chuck McManis
See Also:
  - `CEFormatException`
  - `CharacterEncoder`
  - `BASE64Decoder`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CharacterDecoder()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract int`
  `bytesPerAtom()`
  Return the number of bytes per atom of decoding
  `protected abstract int`
  `bytesPerLine()`
  Return the maximum number of bytes that can be encoded per line
  `protected void`
  `decodeAtom(PushbackInputStream aStream, OutputStream bStream, int l)`
  This method does an actual decode.
  `byte[]`
  `decodeBuffer(InputStream in)`
  Decode the contents of the inputstream into a buffer.
  `void`
  `decodeBuffer(InputStream aStream, OutputStream bStream)`
  Decode the text from the InputStream and write the decoded octets to the OutputStream.
  `byte[]`
  `decodeBuffer(String inputString)`
  Alternate decode interface that takes a String containing the encoded buffer and returns a byte array containing the data.
  `protected void`
  `decodeBufferPrefix(PushbackInputStream aStream, OutputStream bStream)`
  decode the beginning of the buffer, by default this is a NOP.
  `protected void`
  `decodeBufferSuffix(PushbackInputStream aStream, OutputStream bStream)`
  decode the buffer suffix, again by default it is a NOP.
  `ByteBuffer`
  `decodeBufferToByteBuffer(InputStream in)`
  Decode the contents of the inputStream into a ByteBuffer.
  `ByteBuffer`
  `decodeBufferToByteBuffer(String inputString)`
  Decode the contents of the String into a ByteBuffer.
  `protected int`
  `decodeLinePrefix(PushbackInputStream aStream, OutputStream bStream)`
  This method should return, if it knows, the number of bytes that will be decoded.
  `protected void`
  `decodeLineSuffix(PushbackInputStream aStream, OutputStream bStream)`
  This method post processes the line, if there are error detection or correction codes in a line, they are generally processed by this method.
  `protected int`
  `readFully(InputStream in, byte[] buffer, int offset, int len)`
  This method works around the bizarre semantics of BufferedInputStream's read method.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CharacterDecoder

    public CharacterDecoder()

- ## Method Details

  - ### bytesPerAtom

    protected abstract int bytesPerAtom()
    Return the number of bytes per atom of decoding

  - ### bytesPerLine

    protected abstract int bytesPerLine()
    Return the maximum number of bytes that can be encoded per line

  - ### decodeBufferPrefix

    protected void decodeBufferPrefix(PushbackInputStream aStream, OutputStream bStream) throws IOException
    decode the beginning of the buffer, by default this is a NOP.
    Throws:
      `IOException`

  - ### decodeBufferSuffix

    protected void decodeBufferSuffix(PushbackInputStream aStream, OutputStream bStream) throws IOException
    decode the buffer suffix, again by default it is a NOP.
    Throws:
      `IOException`

  - ### decodeLinePrefix

    protected int decodeLinePrefix(PushbackInputStream aStream, OutputStream bStream) throws IOException
    This method should return, if it knows, the number of bytes that will be decoded. Many formats such as uuencoding provide this information. By default we return the maximum bytes that could have been encoded on the line.
    Throws:
      `IOException`

  - ### decodeLineSuffix

    protected void decodeLineSuffix(PushbackInputStream aStream, OutputStream bStream) throws IOException
    This method post processes the line, if there are error detection or correction codes in a line, they are generally processed by this method. The simplest version of this method looks for the (newline) character.
    Throws:
      `IOException`

  - ### decodeAtom

    protected void decodeAtom(PushbackInputStream aStream, OutputStream bStream, int l) throws IOException
    This method does an actual decode. It takes the decoded bytes and writes them to the OutputStream. The integer l tells the method how many bytes are required. This is always <= bytesPerAtom().
    Throws:
      `IOException`

  - ### readFully

    protected int readFully(InputStream in, byte[] buffer, int offset, int len) throws IOException
    This method works around the bizarre semantics of BufferedInputStream's read method.
    Throws:
      `IOException`

  - ### decodeBuffer

    public void decodeBuffer(InputStream aStream, OutputStream bStream) throws IOException
    Decode the text from the InputStream and write the decoded octets to the OutputStream. This method runs until the stream is exhausted.
    Throws:
      `CEFormatException` - An error has occured while decoding
      `CEStreamExhausted` - The input stream is unexpectedly out of data
      `IOException`

  - ### decodeBuffer

    public byte[] decodeBuffer(String inputString) throws IOException
    Alternate decode interface that takes a String containing the encoded buffer and returns a byte array containing the data.
    Throws:
      `CEFormatException` - An error has occured while decoding
      `IOException`

  - ### decodeBuffer

    public byte[] decodeBuffer(InputStream in) throws IOException
    Decode the contents of the inputstream into a buffer.
    Throws:
      `IOException`

  - ### decodeBufferToByteBuffer

    public ByteBuffer decodeBufferToByteBuffer(String inputString) throws IOException
    Decode the contents of the String into a ByteBuffer.
    Throws:
      `IOException`

  - ### decodeBufferToByteBuffer

    public ByteBuffer decodeBufferToByteBuffer(InputStream in) throws IOException
    Decode the contents of the inputStream into a ByteBuffer.
    Throws:
      `IOException`